/**
 * 最初の著者:: トゥイー
 * リポジトリ情報:: $Id: RefCountPtr.hpp 11 2011-05-14 02:11:18Z yutaka_at_home $
 * 著作権:: Copyright (C) Ownway.info, 2011. All rights reserved.
 * ライセンス:: CPL(Common Public Licence)
 */

#ifndef _UTILITY_REF_COUNT_PTR_HPP_
#define _UTILITY_REF_COUNT_PTR_HPP_

#include "tops/utilities/Pointer/MessageCounter.hpp"

namespace Utility {

	/**
	 * 参照カウント型のスマートポインタです。
	 *
	 * @author トゥイー
	 */
	template<class T>
	class RefCountPtr {
	private:
		T* m_ptr;
		MessageCounter* m_count;

	public:
		/**
		 * スマートポインタを構築します。
		 */
		explicit RefCountPtr(T* p = 0) : m_ptr(p), m_count(new MessageCounter(1)) {
		}

		/**
		 * 継承を考慮したコピーコンストラクタです。
		 */
		template<class R>
		RefCountPtr(const RefCountPtr<R>& rhs) :
		m_ptr(rhs.get()), m_count(rhs.getCounter()) {
			++(*m_count);
		}

		/*
		 * コピーコンストラクタです。
		 */
		RefCountPtr(const RefCountPtr<T>& rhs) :
		m_ptr(rhs.m_ptr), m_count(rhs.m_count) {
			++(*m_count);
		}

		/**
		 * スマートポインタを破棄します。
		 */
		virtual ~RefCountPtr() {
			refcountdec();
		}

	public:
		/**
		 * 継承を考慮した代入演算子です。
		 */
		template<class R>
		RefCountPtr<T>& operator=(const RefCountPtr<R>& rhs) {
			if (m_ptr != rhs.get()) {
				refcountdec();
				m_ptr = rhs.get();
				m_count = rhs.getCounter();
				++(*m_count);
			}

			return *this;
		}

		/**
		 * 代入演算子です。
		 */
		RefCountPtr<T>& operator=(const RefCountPtr<T>& rhs) {
			if (m_ptr != rhs.get()) {
				refcountdec();
				m_ptr = rhs.get();
				m_count = rhs.getCounter();
				++(*m_count);
			}

			return *this;
		}

	public:
		/**
		 * ポインタが値を持つかどうかを判定します。
		 *
		 * @return ポインタが値を持つ場合はtrueを、NULLの場合はfalseを返します。
		 */
		operator bool() const {
			return 0 != m_ptr;
		}

		/**
		 * ポインタがNULL値かどうかを判定します。
		 *
		 * @return ポインタがNULLの場合はtrueを、値を持つ場合はfalseを返します。
		 */
		bool operator!() const {
			return 0 == m_ptr;
		}

	public:
		/**
		 * 参照はずし演算子です。
		 */
		T& operator*() const {
			return *m_ptr;
		}

		/**
		 * 参照はずし演算子です。
		 */
		T* operator->() const {
			return m_ptr;
		}

		/**
		 * 生ポインタを取得します。
		 */
		T* get() const {
			return m_ptr;
		}

		/**
		 * カウントポインタを取得します。
		 */
		MessageCounter* getCounter() const {
			return m_count;
		}

	public:
		/**
		 * 等価演算子です。
		 */
		bool operator==(const RefCountPtr<T>& rhs) {
			return m_ptr == rhs.m_ptr;
		}

		/**
		 * 等値演算子です。
		 */
		bool operator< (const RefCountPtr<T>& rhs) {
			return m_ptr <  rhs.m_ptr;
		}

	private:
		void refcountdec() {
			--(*m_count);

			if ((*m_count) == 0) {
				delete m_ptr;
				m_ptr = 0;
				delete m_count;
				m_count = 0;
			}
		}
	};

}  // namespace Utility

#endif
